package ecs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateStorageSet invokes the ecs.CreateStorageSet API synchronously
func (client *Client) CreateStorageSet(request *CreateStorageSetRequest) (response *CreateStorageSetResponse, err error) {
	response = CreateCreateStorageSetResponse()
	err = client.DoAction(request, response)
	return
}

// CreateStorageSetWithChan invokes the ecs.CreateStorageSet API asynchronously
func (client *Client) CreateStorageSetWithChan(request *CreateStorageSetRequest) (<-chan *CreateStorageSetResponse, <-chan error) {
	responseChan := make(chan *CreateStorageSetResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateStorageSet(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateStorageSetWithCallback invokes the ecs.CreateStorageSet API asynchronously
func (client *Client) CreateStorageSetWithCallback(request *CreateStorageSetRequest, callback func(response *CreateStorageSetResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateStorageSetResponse
		var err error
		defer close(result)
		response, err = client.CreateStorageSet(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateStorageSetRequest is the request struct for api CreateStorageSet
type CreateStorageSetRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ClientToken          string           `position:"Query" name:"ClientToken"`
	MaxPartitionNumber   requests.Integer `position:"Query" name:"MaxPartitionNumber"`
	Description          string           `position:"Query" name:"Description"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	ZoneId               string           `position:"Query" name:"ZoneId"`
	StorageSetName       string           `position:"Query" name:"StorageSetName"`
}

// CreateStorageSetResponse is the response struct for api CreateStorageSet
type CreateStorageSetResponse struct {
	*responses.BaseResponse
	StorageSetId string `json:"StorageSetId" xml:"StorageSetId"`
	RequestId    string `json:"RequestId" xml:"RequestId"`
}

// CreateCreateStorageSetRequest creates a request to invoke CreateStorageSet API
func CreateCreateStorageSetRequest() (request *CreateStorageSetRequest) {
	request = &CreateStorageSetRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ecs", "2014-05-26", "CreateStorageSet", "ecs", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateStorageSetResponse creates a response to parse from CreateStorageSet response
func CreateCreateStorageSetResponse() (response *CreateStorageSetResponse) {
	response = &CreateStorageSetResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
