package slb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SetLoadBalancerHTTPSListenerAttribute invokes the slb.SetLoadBalancerHTTPSListenerAttribute API synchronously
func (client *Client) SetLoadBalancerHTTPSListenerAttribute(request *SetLoadBalancerHTTPSListenerAttributeRequest) (response *SetLoadBalancerHTTPSListenerAttributeResponse, err error) {
	response = CreateSetLoadBalancerHTTPSListenerAttributeResponse()
	err = client.DoAction(request, response)
	return
}

// SetLoadBalancerHTTPSListenerAttributeWithChan invokes the slb.SetLoadBalancerHTTPSListenerAttribute API asynchronously
func (client *Client) SetLoadBalancerHTTPSListenerAttributeWithChan(request *SetLoadBalancerHTTPSListenerAttributeRequest) (<-chan *SetLoadBalancerHTTPSListenerAttributeResponse, <-chan error) {
	responseChan := make(chan *SetLoadBalancerHTTPSListenerAttributeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SetLoadBalancerHTTPSListenerAttribute(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SetLoadBalancerHTTPSListenerAttributeWithCallback invokes the slb.SetLoadBalancerHTTPSListenerAttribute API asynchronously
func (client *Client) SetLoadBalancerHTTPSListenerAttributeWithCallback(request *SetLoadBalancerHTTPSListenerAttributeRequest, callback func(response *SetLoadBalancerHTTPSListenerAttributeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SetLoadBalancerHTTPSListenerAttributeResponse
		var err error
		defer close(result)
		response, err = client.SetLoadBalancerHTTPSListenerAttribute(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SetLoadBalancerHTTPSListenerAttributeRequest is the request struct for api SetLoadBalancerHTTPSListenerAttribute
type SetLoadBalancerHTTPSListenerAttributeRequest struct {
	*requests.RpcRequest
	ResourceOwnerId                          requests.Integer                                          `position:"Query" name:"ResourceOwnerId"`
	ServerCertificate                        *[]SetLoadBalancerHTTPSListenerAttributeServerCertificate `position:"Query" name:"ServerCertificate"  type:"Repeated"`
	HealthCheckTimeout                       requests.Integer                                          `position:"Query" name:"HealthCheckTimeout"`
	XForwardedFor                            string                                                    `position:"Query" name:"XForwardedFor"`
	HealthCheckURI                           string                                                    `position:"Query" name:"HealthCheckURI"`
	XForwardedForSLBPORT                     string                                                    `position:"Query" name:"XForwardedFor_SLBPORT"`
	AclStatus                                string                                                    `position:"Query" name:"AclStatus"`
	AclType                                  string                                                    `position:"Query" name:"AclType"`
	HealthCheck                              string                                                    `position:"Query" name:"HealthCheck"`
	VpcIds                                   string                                                    `position:"Query" name:"VpcIds"`
	VServerGroupId                           string                                                    `position:"Query" name:"VServerGroupId"`
	AclId                                    string                                                    `position:"Query" name:"AclId"`
	XForwardedForClientCertClientVerify      string                                                    `position:"Query" name:"XForwardedFor_ClientCertClientVerify"`
	Cookie                                   string                                                    `position:"Query" name:"Cookie"`
	HealthCheckMethod                        string                                                    `position:"Query" name:"HealthCheckMethod"`
	HealthCheckDomain                        string                                                    `position:"Query" name:"HealthCheckDomain"`
	RequestTimeout                           requests.Integer                                          `position:"Query" name:"RequestTimeout"`
	OwnerId                                  requests.Integer                                          `position:"Query" name:"OwnerId"`
	CACertificateId                          string                                                    `position:"Query" name:"CACertificateId"`
	BackendProtocol                          string                                                    `position:"Query" name:"BackendProtocol"`
	Tags                                     string                                                    `position:"Query" name:"Tags"`
	XForwardedForClientCertFingerprintAlias  string                                                    `position:"Query" name:"XForwardedFor_ClientCertFingerprintAlias"`
	LoadBalancerId                           string                                                    `position:"Query" name:"LoadBalancerId"`
	XForwardedForSLBIP                       string                                                    `position:"Query" name:"XForwardedFor_SLBIP"`
	HealthCheckInterval                      requests.Integer                                          `position:"Query" name:"HealthCheckInterval"`
	XForwardedForClientCertClientVerifyAlias string                                                    `position:"Query" name:"XForwardedFor_ClientCertClientVerifyAlias"`
	XForwardedForSLBID                       string                                                    `position:"Query" name:"XForwardedFor_SLBID"`
	XForwardedForClientCertFingerprint       string                                                    `position:"Query" name:"XForwardedFor_ClientCertFingerprint"`
	AccessKeyId                              string                                                    `position:"Query" name:"access_key_id"`
	XForwardedForClientSrcPort               string                                                    `position:"Query" name:"XForwardedFor_ClientSrcPort"`
	Description                              string                                                    `position:"Query" name:"Description"`
	UnhealthyThreshold                       requests.Integer                                          `position:"Query" name:"UnhealthyThreshold"`
	XForwardedForClientCertIssuerDNAlias     string                                                    `position:"Query" name:"XForwardedFor_ClientCertIssuerDNAlias"`
	HealthyThreshold                         requests.Integer                                          `position:"Query" name:"HealthyThreshold"`
	Scheduler                                string                                                    `position:"Query" name:"Scheduler"`
	MaxConnection                            requests.Integer                                          `position:"Query" name:"MaxConnection"`
	EnableHttp2                              string                                                    `position:"Query" name:"EnableHttp2"`
	XForwardedForClientCertSubjectDN         string                                                    `position:"Query" name:"XForwardedFor_ClientCertSubjectDN"`
	CookieTimeout                            requests.Integer                                          `position:"Query" name:"CookieTimeout"`
	StickySessionType                        string                                                    `position:"Query" name:"StickySessionType"`
	ListenerPort                             requests.Integer                                          `position:"Query" name:"ListenerPort"`
	HealthCheckType                          string                                                    `position:"Query" name:"HealthCheckType"`
	ResourceOwnerAccount                     string                                                    `position:"Query" name:"ResourceOwnerAccount"`
	Bandwidth                                requests.Integer                                          `position:"Query" name:"Bandwidth"`
	StickySession                            string                                                    `position:"Query" name:"StickySession"`
	OwnerAccount                             string                                                    `position:"Query" name:"OwnerAccount"`
	Gzip                                     string                                                    `position:"Query" name:"Gzip"`
	TLSCipherPolicy                          string                                                    `position:"Query" name:"TLSCipherPolicy"`
	ServerCertificateId                      string                                                    `position:"Query" name:"ServerCertificateId"`
	IdleTimeout                              requests.Integer                                          `position:"Query" name:"IdleTimeout"`
	XForwardedForProto                       string                                                    `position:"Query" name:"XForwardedFor_proto"`
	XForwardedForClientCertSubjectDNAlias    string                                                    `position:"Query" name:"XForwardedFor_ClientCertSubjectDNAlias"`
	HealthCheckConnectPort                   requests.Integer                                          `position:"Query" name:"HealthCheckConnectPort"`
	HealthCheckHttpCode                      string                                                    `position:"Query" name:"HealthCheckHttpCode"`
	VServerGroup                             string                                                    `position:"Query" name:"VServerGroup"`
	XForwardedForClientCertIssuerDN          string                                                    `position:"Query" name:"XForwardedFor_ClientCertIssuerDN"`
}

// SetLoadBalancerHTTPSListenerAttributeServerCertificate is a repeated param struct in SetLoadBalancerHTTPSListenerAttributeRequest
type SetLoadBalancerHTTPSListenerAttributeServerCertificate struct {
	BindingType   string `name:"BindingType"`
	CertificateId string `name:"CertificateId"`
	StandardType  string `name:"StandardType"`
}

// SetLoadBalancerHTTPSListenerAttributeResponse is the response struct for api SetLoadBalancerHTTPSListenerAttribute
type SetLoadBalancerHTTPSListenerAttributeResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateSetLoadBalancerHTTPSListenerAttributeRequest creates a request to invoke SetLoadBalancerHTTPSListenerAttribute API
func CreateSetLoadBalancerHTTPSListenerAttributeRequest() (request *SetLoadBalancerHTTPSListenerAttributeRequest) {
	request = &SetLoadBalancerHTTPSListenerAttributeRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Slb", "2014-05-15", "SetLoadBalancerHTTPSListenerAttribute", "Slb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateSetLoadBalancerHTTPSListenerAttributeResponse creates a response to parse from SetLoadBalancerHTTPSListenerAttribute response
func CreateSetLoadBalancerHTTPSListenerAttributeResponse() (response *SetLoadBalancerHTTPSListenerAttributeResponse) {
	response = &SetLoadBalancerHTTPSListenerAttributeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
